/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.layout;

import java.awt.*;
import java.awt.event.*;

/**
 *  Description of the Interface
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public interface ActorEventHandler extends ActorDelegate {

    public boolean canPerformIncrementalDrag(int deltaX, int deltaY);

    public boolean getIsDraggable();

    public boolean getIsDragging();

    public boolean getIsResizable();

    public boolean getIsResizing();

    public boolean getIsSelectable();

    public boolean getIsSelected();

    public void processClick(MouseEvent e);

    public void processDrag(MouseEvent e);

    public void processIncrementalDrag(int deltaX, int deltaY);

    public void processMousePress(MouseEvent e);

    public void processMouseRelease(MouseEvent e);

    public void setIsDraggable(boolean isDraggable);

    public void setIsResizable(boolean isResizable);

    public void setIsSelectable(boolean isSelectable);

    public void setIsSelected(boolean isSelected);

    public boolean wantEvent(MouseEvent e);
}
