/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.layout;

/**
 *  Description of the Interface
 *
 * @author William Grosso <grosso@smi.stanford.edu>
 */
public interface ControlPoints {
    public final static int NOT_A_VALID_CONTROL_POINT = -1;

    // for images
    public final static int UPPER_LEFT = 0;
    public final static int UPPER_MIDDLE = 1;
    public final static int UPPER_RIGHT = 2;
    public final static int MIDDLE_LEFT = 3;
    public final static int MIDDLE = 4;
    public final static int MIDDLE_RIGHT = 5;
    public final static int LOWER_LEFT = 6;
    public final static int LOWER_MIDDLE = 7;
    public final static int LOWER_RIGHT = 8;

    // for wires
    public final static int BEGINNING = 0;
    public final static int END = 1;

}
