/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.layout;

import java.awt.*;

/**
 *  Description of the class
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public class Hexagon extends Polygon {

    public Hexagon() {
        xPoints = new int[6];
        yPoints = new int[6];
    }

    protected void buildPolygon(java.awt.Rectangle location) {
        int widthDividedBy3 = (location.width / 3);
        xPoints[0] = location.x;
        xPoints[1] = location.x + widthDividedBy3;
        xPoints[2] = xPoints[1] + widthDividedBy3;
        xPoints[3] = location.x + location.width;
        xPoints[4] = xPoints[2];
        xPoints[5] = xPoints[1];
        yPoints[0] = location.y + (location.height / 2);
        yPoints[1] = location.y;
        yPoints[2] = location.y;
        yPoints[3] = yPoints[0];
        yPoints[4] = location.y + location.height;
        yPoints[5] = yPoints[4];
    }
}
