/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.layout;

import java.awt.*;
import java.awt.event.*;

/**
 *  Pretty much a null object
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public class NullMovementHandler extends ActorDelegateImpl implements ActorMovementHandler {

    public NullMovementHandler(Actor actor) {
        super(actor);
    }

    public boolean collidesWithActor(Actor actor) {
        return false;
    }

    public void collideWithActor(Actor actor) {
        return;
    }

    public Object copy() {
        return this;
    }

    public boolean getBounces() {
        return false;
    }

    public double getXVelocity() {
        return ActorMovementHandler.ZERO_VELOCITY;
    }

    public double getYVelocity() {
        return ActorMovementHandler.ZERO_VELOCITY;
    }

    public void setBounces(boolean bounces) {

        return;
    }

    public void setXVelocity(double xVelocity) {
        throw new Error("Somone tried to set the x velocity of a null movement handler.");
    }

    public void setYVelocity(double yVelocity) {
        throw new Error("Somone tried to set the y velocity of a null movement handler.");
    }

    public void tick(int currentTime) {
        return;
    }
}
