/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.storage.rdf.oil;

import edu.stanford.smi.protegex.storage.walker.*;
import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protegex.storage.rdf.*;
import edu.stanford.smi.protegex.storage.walker.protege.*;

public class OilProtegeFrame extends ProtegeFrame {

  public OilProtegeFrame(Frame frame, KnowledgeBase kb,
      Namespaces namespaces, FrameCreator creator) {
    super(frame, kb, namespaces, creator);
  }

  public boolean isThing() {
    return _frame.getName().equals("oil:Top") || super.isThing();
  }

  public boolean isStandardClass() {
    return _frame.getName().equals("oil:Class") || super.isStandardClass();
  }

  public boolean isStandardSlot() {
    return _frame.getName().equals("oil:Property") || super.isStandardSlot();
  }

}


