/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.storage.walker;

public class SimpleWalkerFrame implements WalkerFrame {

  String _name;
  String _namespace;
  String _localName;
  boolean _isClass;
  boolean _isSlot;
  boolean _isThing;
  boolean _isStandardClass;
  boolean _isStandardSlot;

  public SimpleWalkerFrame(String namespace, String localName, 
      boolean isClass, boolean isSlot) {
    this(namespace, localName, isClass, isSlot,
      false, false, false);
  }

  public SimpleWalkerFrame(String namespace, String localName, 
      boolean isClass, boolean isSlot, 
      boolean isThing, boolean isStandardClass, boolean isStandardSlot) {
    _namespace = namespace;
    _localName = localName;
    _name = namespace + ":" + localName;
    _isClass = isClass;
    _isSlot = isSlot;
    _isThing = isThing;
    _isStandardClass = isStandardClass;
    _isStandardSlot = isStandardSlot;
  }

  public String getName() {
    return _name;
  }

  public String getDisplayName() {
    return _name;
  }

  public String getNamespace() {
    return _namespace;
  }

  public String getLocalName() {
    return _localName;
  }

  public String toString() {
    return getName();
  }

  public boolean isClass() {
    return _isClass;
  }

  public boolean isSlot() {
    return _isSlot;
  }

  public boolean isThing() {
    return _isThing;
  }

  public boolean isStandardClass() {
    return _isStandardClass;
  }

  public boolean isStandardSlot() {
    return _isStandardSlot;
  }


}


