/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.storage.walker;


public interface WalkerFrame {

  public String getName(); // full unique name

  public String getDisplayName(); // for GUIs/browsers etc., not
    // necessarily unique

  public String getNamespace();

  public String getLocalName();

  // test for type

  public boolean isClass();

  public boolean isSlot();

  // test for special frames

  public boolean isThing(); // :THING, rdf:Resource, Top etc.

  public boolean isStandardClass(); // :STANDARD-CLASS, rdfs:Class, etc.

  public boolean isStandardSlot(); // :STANDARD-SLOT, rdf:Property, etc.

  // add: isConstraint (:CONSTRAINT, rdfs.ConstraintResource); 
  //      isConstraintSlot (for rdfs:ConstraintProperty) ??

}


