/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.widget.abstracttable;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;
import edu.stanford.smi.protege.util.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;
import edu.stanford.smi.protege.model.Frame;
import java.util.List;

/**
 *  Description of the Class
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public class InstanceEditor_PullDownMenu extends FrameEditor_PullDownMenu {

    public InstanceEditor_PullDownMenu(JComponent onScreenComponent, Project project) {
        this(onScreenComponent, project, null, null);
    }

    public InstanceEditor_PullDownMenu(JComponent onScreenComponent, Project project, Instance instance, Slot slot) {
        super(onScreenComponent, project, instance, slot);
    }

    protected List getPossibleChoices() {
        ArrayList returnValue = new ArrayList();
        if ((null == _instance) || (null == _slot)) {
            return returnValue;
        }
        Cls cls = _instance.getDirectType();
        Collection allowedClasses = cls.getTemplateSlotAllowedClses(_slot);
        Iterator i = allowedClasses.iterator();
        while (i.hasNext()) {
            returnValue.addAll(((Cls) i.next()).getInstances());
        }
        returnValue.remove(_value);
        return returnValue;
    }
}
