/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.widget.diagram;

import edu.stanford.smi.protegex.layout.*;
import edu.stanford.smi.protegex.util.*;

import edu.stanford.smi.protege.widget.*;
import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;
import edu.stanford.smi.protege.util.*;
import javax.swing.*;
import java.util.*;

/**
 *  Description of the class
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public class DiagramWidgetConfigurationPanel extends WidgetConfigurationPanel {
    private DiagramWidgetState _state;

    public DiagramWidgetConfigurationPanel(DiagramWidget widget) {
        super(widget);
        _state = widget.getState();
        addTab("Node Configuration", new NodeTablePanel(widget));
        addTab("Wire Configuration", new WireTablePanel(widget));
        addTab("Action Buttons", new SixButtonsConfigurationPanel(_state));
        addTab("Instance Prototyping", new PrototypingConfigurationPanel(_state));
        addTab("Choose Miniwindows", new MiniwindowActivationPanel(_state));
        addTab("Overall Layout", new SizeConfigurationPanel(_state));
    }

    public void saveContents() {
        super.saveContents();
        _state.save();
    }
}
