/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.widget.diagram;

import edu.stanford.smi.protegex.layout.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *  Description of the class
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public class DiagramsPanelWithoutPalette extends DiagramsPanel {

    public DiagramsPanelWithoutPalette(DiagramWidget widget) {
        super(widget);
        enableEvents(AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK);
    }

    public void finishInitialization() {
        this.add(_mainDrawingAreaScrollPane, BorderLayout.CENTER);
    }

    protected void processMouseEvent(MouseEvent mouseEvent) {
        Point locationOfEvent = mouseEvent.getPoint();
        if (_mainDrawingPanel.wantsEventAtLocation(locationOfEvent)) {
            _mainDrawingPanel.forwardMouseEvent(mouseEvent);
        }
    }

    protected void processMouseMotionEvent(MouseEvent mouseEvent) {
        Point locationOfEvent = mouseEvent.getPoint();
        if (_mainDrawingPanel.wantsEventAtLocation(locationOfEvent)) {
            _mainDrawingPanel.forwardMouseMotionEvent(mouseEvent);
        }
    }

    public void setBounds(int x, int y, int width, int height) {
        super.setBounds(0, 0, width, height);
    }
}
