/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * Contributor(s):
 */

package edu.stanford.smi.protegex.widget.oil;

public interface OilConstants {

  final static String CLASS = "oil:Class";
  final static String TYPE = "oil:type";
  // final static String DEFINEDCLASS = "oil:DefinedClass";
  // final static String PRIMITIVECLASS = "oil:PrimitiveClass";
  final static String SUBCLASSOF = "oil:subClassOf";
  final static String DIRECTSUPERCLASSES = ":DIRECT-SUPERCLASSES";
  final static String HASPROPERTYRESTRICTION = "oil:hasPropertyRestriction";
  final static String EXPRESSION = "oil:Expression";
  final static String AND = "oil:And";
  final static String OR = "oil:Or";
  final static String NOT = "oil:Not";
  final static String HASOPERAND = "oil:hasOperand";
  final static String VALUETYPE = "oil:ValueType";
  final static String HASVALUE= "oil:HasValue";
  final static String ONPROPERTY = "oil:onProperty";
  final static String TOCLASS = "oil:toClass";
  final static String MAXCARDINALITY = "oil:MaxCardinality";
  final static String MINCARDINALITY = "oil:MinCardinality";
  final static String CARDINALITY = "oil:Cardinality";
  final static String NUMBER = "oil:number";
  final static String PROPERTY = "oil:OilProperty";
  final static String DOMAIN = "oil:domain";
  final static String RANGE = "oil:range";
  final static String SUBPROPERTYOF = "oil:subPropertyOf";
  final static String INVERSEPROPERTY = ":SLOT-INVERSE";
  final static String SLOTPROPERTIES = "oil:properties";
  final static String TRANSITIVE = "oil:transitive";
  final static String SYMMETRIC = "oil:symmetric";
  final static String FUNCTIONAL = "oil:functional";
  final static String AXIOM = "oil:Axiom";
  final static String HASOBJECT = "oil:hasObject";
  final static String DISJOINT = "oil:Disjoint";
  final static String EQUIVALENCE = "oil:Equivalence";
  final static String HASSUBJECT = "oil:hasSubject";
  final static String COVER = "oil:Cover";
  final static String DISJOINTCOVER = "oil:DisjointCover";

  final static String COLONTHING = ":THING";

  final static String TOP = "oil:Top";
  final static String BOTTOM = "oil:Bottom";

}


