#!/usr/bin/perl -w

#  protege_to_jena.pl
#  Change rdfs-file created by Protg so that it works with Jena
#  Arno Aalto 25.7.2002
#  TKOL Keltsi-projekti

### Customize this section

# What are the names of the files?
@files = ("KeltsiData.rdf", "restaurant.rdfs");

# Where to find Protege-generated rdfs-file
$protege_dir = ".";

# Where to place file
$jena_dir = "../rdfbase";

### End of customization, unless you want to change the changes...

foreach my $file (@files) {
    open PROTEGE, "<$protege_dir/$file"
    or die "Can't open '$protege_dir/$file' to read!";

    open JENA, ">$jena_dir/$file"
    or die "Can't open $jena_dir/$file to write";

    while (my $line = <PROTEGE>) {

        # change rdfs-namespace
        $line =~ s!http://www.w3.org/TR/1999/PR-rdf-schema-19990303#!http://www.w3.org/2000/01/rdf-schema#!;

        # change KeltsiClass (a subclass of rdfs:Class) to rdfs:Class
        $line =~ s/\bKeltsi:KeltsiClass\b/rdfs:Class/;

        print JENA $line;
    }
    close JENA;
    close PROTEGE;
}
