/*
$Author: hatinen $
$Revision: 1.1 $ $Date: 2002/07/23 08:42:31 $

$Log $

*/

package fi.helsinki.cs.keltsi.functest;

import junit.framework.*;
import java.lang.*;
import java.io.*;

/**
 * Functional test to test is CVS working.
 */
public class TestCVS extends TestCase {

    // junit standard methods

    /**
     * Constructor.
     * @param String theName
     */
    public TestCVS(String theName) {
	super(theName);
    }

    /**
     * main
     * @param String[] arguments (not used)
     */
    public static void main(String[] theArgs) {
	junit.textui.TestRunner.main(new String[] {TestCVS.class.getName()});
    }

    /**
     * Build a test <code>suite</code>.
     */
    public static Test suite() {
	return new TestSuite(TestCVS.class);
    }

    // test methods

    private final String CVSROOT="/home/group/keltsi/cvsroot";

    /**
     * Test is CVS present.
     */   
    public void testIsCVSWorking() throws IOException {
	// Is cvsroot set ?
	//String cvsroot = System.getProperty("cvsroot");
	//String cvsroot = System.getenv("CVSROOT");
        //assertEquals(CVSROOT,cvsroot);

	// does cvs exist ?
	String[] envp = new String[1];
	envp[0] = "cvsroot="+CVSROOT;
	Process cvs = Runtime.getRuntime().exec("cvs version",envp);
        BufferedReader syotto =  
	    new BufferedReader(
			       new InputStreamReader(
						     cvs.getInputStream()
						     )
			       );

	String rivi="";

	while((rivi = syotto.readLine()) != null) 
	 {
	    System.out.println(rivi);
	    assertTrue(rivi.indexOf("Concurrent Versions System")>=0);
	 }
       
	// does cvs checkout work?

    }
}
