/*
$Author: hatinen $
$Revision: 1.1 $ $Date: 2002/07/23 08:42:31 $

$Log $

*/

//package fi.helsinki.cs.keltsi.functest;

import junit.framework.*;
import java.lang.*;
import java.io.*;

/**
 * Functional test to test is CVS working.
 */

public class TestRDQL2 extends TestCase {

    // junit standard methods

    /**
     * Constructor.
     * @param String theName
     */
    public TestRDQL2(String theName) {
	super(theName);
    }

    /**
     * main
     * @param String[] arguments (not used)
     */
    public static void main(String[] theArgs) {
	junit.textui.TestRunner.main(new String[] {TestRDQL2.class.getName()});
    }

    /**
     * Build a test <code>suite</code>.
     */
    public static Test suite() {
	return new TestSuite(TestRDQL2.class);
    }

    // test methods

    private final String JenaRDQLROOT="/home/group/keltsi/cvsroot";

    /**
     * Test getting sub classes of HotelsAndMotelsAndInns.
     */   
         public void testGetSubClasses() throws Exception {

       LinkedListHandler resultSet = 
	   KeltsiJenaQuery.getSubClasses("HotelsAndMotelsAndInns");
       
       String[] result = resultSet.toStringArray();
       
       String expectedResult = 
	   "http://protege.stanford.edu/Keltsi#BedAndBreakfastInns";

       assertEquals(expectedResult, result[0]);
       assertTrue(result.length == 4);
    }
     
    
   /**
    * Test getting properties of Services. 
    */   
      public void testGetPropertiesOfAClass() throws Exception {
      
      LinkedListHandler resultSet = 
         KeltsiJenaQuery.getPropertiesOfAClass("Services");
      
       String[] result = resultSet.toStringArray();
       
       String expectedResult = 
	  "http://protege.stanford.edu/Keltsi#additionalServices";

       assertEquals(expectedResult, result[0]);
         assertTrue(result.length == 4);
    }
      
   /**
    * Test getting classes connected to a property. 
    */   
     public void testGetClassesConnectedToAProperty() throws Exception {
      
      LinkedListHandler resultSet = 
	  KeltsiJenaQuery.getClassesConnectedToAProperty("restaurantType");
      
      String[] result = resultSet.toStringArray();
      
      String expectedResult = 
	  "http://protege.stanford.edu/Keltsi#RestaurantsAndCatering";
      
      assertEquals(expectedResult, result[0]);
          assertTrue(result.length == 1);
   }
    

}
