package fi.helsinki.cs.keltsi.tags;

import fi.helsinki.cs.keltsi.utils.*;
import fi.helsinki.cs.keltsi.jenardf.*;

import com.hp.hpl.mesa.rdf.jena.model.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import java.util.*;
import javax.servlet.jsp.PageContext;

/** Shows all the parameters sent to the servlet via either
 *  GET or POST. 
 */

public class FormHandler extends TagSupport {

    public int doStartTag() throws JspException {

	String rdfClass="";

        try {
	    HttpServletRequest req =
		(HttpServletRequest)pageContext.getRequest();

		rdfClass = req.getParameter("rdfClass");
	} catch (Exception e) {
	}
	try {

	    /* Create keltsi-query-knowledge-base-object. */
	    KeltsiJenaQuery kjq = new KeltsiJenaQuery();

	    /* Get a Resource class. */
	    if (rdfClass == null) rdfClass = "Services";

	    Resource aClass = (Resource)kjq
		.getResourceByURI(kjq.keltsiNS + rdfClass);


	/* subClasses */
	    LinkedListHandler ll = kjq.getSubClasses(aClass);
	    ListIterator handler = ll.listIterator();
	    boolean hasSubClasses = false;

	    while(handler.hasNext() == true)
	    {
	        hasSubClasses = true;
		Resource subClass = (Resource)handler.next();
	    	pageContext.getOut().write(
			"<li><a href='main.jsp?rdfClass="+kjq.getLocalName(subClass)+"'>"+
			kjq.getLabel(subClass)+"</a></li>"
		);
	    }


	ll = kjq.getAllInstancesOfAClass(aClass);
	if (hasSubClasses){
		pageContext.getOut().write("<li>"+ll.size()+" instances</li>");
	} else {
		handler = ll.listIterator();
		while(handler.hasNext() == true) {
			Resource instance = (Resource)handler.next();
			pageContext.getOut().write(
				"<li>" + kjq.getLocalName(instance) + "</li>"
			);
		}
	}

	/* all properties */
	    ll = kjq.getAllPropertiesOfAClass(aClass);
	    handler = ll.listIterator();

	    while(handler.hasNext() == true) {
		Resource property = (Resource)handler.next();
	    	pageContext.getOut().write(
			"<li>" + kjq.getLocalName(property) + "</li>"
		);
	    }


	}catch(Exception e) {
	}
	return SKIP_BODY;
    }
}
