package fi.helsinki.cs.keltsi.tags;

import fi.helsinki.cs.keltsi.util.*;
import fi.helsinki.cs.keltsi.jenardf.*;

import com.hp.hpl.jena.daml.*;
import com.hp.hpl.mesa.rdf.jena.model.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.*;
import java.util.*;
import javax.servlet.jsp.PageContext;

/** 
 *  This tag handler initializes the model (and perhaps some 
 *  other things in application scope).
 */
public class Init extends TagSupport {
    private boolean noModel = true;
    private boolean reload = false;
    private String baseURL;

    /**
     *  To be able to reload model from a jsp.
     */
    public void setReload(String reload) {
        this.reload = (reload != null && reload.equals("on"));
    }
    
    /**
     *  TO be able to set the baseURL from a jsp.
     *  Some default value maybe set elsewhere (now in KeltsiDAML).
     */
    public void setBaseURL(String baseURL) {
        this.baseURL = baseURL;
    }

    public int doStartTag() throws JspException {
        KeltsiDAML kjq;
	    JspWriter out = pageContext.getOut();
	    Html html = new Html(out);
        try {
            /* Get session*/
           
            HttpServletRequest req =
                (HttpServletRequest)pageContext.getRequest();
            HttpSession session = req.getSession(true);
            
            /* Get keltsi-query-knowledge-base-object. */
            ServletContext sc = pageContext.getServletContext();
            kjq = (KeltsiDAML)sc.getAttribute(
                    "fi.helsinki.cs.keltsi.KeltsiDAML");
            if ((kjq == null || reload) ){ 
                kjq = new KeltsiDAML();
                if (baseURL != null) {
                    kjq.setBaseURL(baseURL);
                }
                kjq.loadModel("KeltsiData");
                sc.setAttribute("fi.helsinki.cs.keltsi.KeltsiDAML", kjq);
                /* out.write("<p>Model loaded succesfully!</p>"); */
            }
            pageContext.setAttribute(
                    "fi.helsinki.cs.keltsi.KeltsiDAML", kjq);
            noModel = false;
            try {
                out.write("<!-- Using model " + kjq + " from " + kjq.getBaseURL() + ". -->\n" );
            } catch (Exception ex2) {}
        } catch (Exception e) {
            noModel = true;
            try {
                out.write(
                      "<html>\n"
                    + "\t<head>\n"
                    + "\t\t<title>Error</title>\n"
                    + "\t</head>\n"
                    + "\t<body>\n"
                    + "\t\t<h1>Error loading model</h1>\n"
                    + "\t</body>\n"
                    + "</html>\n");
            } catch (Exception ex2) {}
        }
        return SKIP_BODY;
     }

    public int doEndTag() throws JspException {
        if (noModel) {
            return SKIP_PAGE;
        } else {
            return EVAL_PAGE;
        }
    }
}
