package fi.helsinki.cs.keltsi.tags;

import fi.helsinki.cs.keltsi.jenardf.KeltsiDAML;
import fi.helsinki.cs.keltsi.jenardf.Keltsi;
import fi.helsinki.cs.keltsi.jenardf.KeltsiClass;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.JspWriter;

/**
 *  This tag handler initializes ServiceClass
 *  to be used with classes such as DisplayServiceClass.
 * 
 *  @author Arno Aalto
 */
public class ServiceClassInit extends TagSupport {

    public int doStartTag() throws JspException {
        KeltsiDAML model = null;
        try {
            HttpServletRequest req =
                    (HttpServletRequest)pageContext.getRequest();
            Link link = new Link(req);
            model = (KeltsiDAML) pageContext
                .findAttribute("fi.helsinki.cs.keltsi.KeltsiDAML");

            /* Get value of parameter 'serviceclassuri' */
            String serviceClassUri = null;

            /*   First try synonym */
            String synonym = req.getParameter("serviceclasssynonym");
            if (synonym != null && synonym.length() > 0) {
                serviceClassUri = model.getSynonymClassURI(synonym);
            }
            /* Then try direct parametervalue */
            if (serviceClassUri == null) {
                serviceClassUri = req.getParameter("serviceclassuri");
            }
            link.removeParam("synonym");

            /* Try to get corresponding ServiceClass object */
            KeltsiClass serviceClass = null;
            if (serviceClassUri  != null) {
                serviceClass = (KeltsiClass) model
                        .getKeltsiResource(serviceClassUri);
            }

            /* Missing or invalid value of parameter 'serviceclassuri'
            Default value is the root of the Servicetree.
            TODO: Check if it should be something else
            */
            if (serviceClass == null) {
                serviceClass = Keltsi.ServiceRoot;
                serviceClassUri = serviceClass.getURI();
            }
            link.addParam("serviceclassuri", serviceClassUri);

            pageContext.setAttribute("fi.helsinki.cs.keltsi.ServiceClassLink",
                                    link);
            pageContext.setAttribute("fi.helsinki.cs.keltsi.ServiceClass",
                                    serviceClass);
        } catch(Exception ex) {
            try {
                PrintWriter pw = new PrintWriter(pageContext.getOut(),true);
                ex.printStackTrace(pw);
            } catch(Exception ex2) {}
        }
        return SKIP_BODY;
    }
}
