package fi.helsinki.cs.keltsi.tags.test;

import com.meterware.httpunit.*;

import fi.helsinki.cs.keltsi.jenardf.*;
import fi.helsinki.cs.keltsi.util.*;
import java.io.IOException;
import java.net.MalformedURLException;

import org.xml.sax.*;
import org.w3c.dom.*;

import junit.framework.*;

import java.util.*;

import com.hp.hpl.jena.daml.*;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.common.*;

/**
 * An example of testing servlets using httpunit and JUnit.
 */
public class TestDisplayAdvertisement extends TestCase {
      
   public static void main(String args[]) {	
      junit.textui.TestRunner.run( suite() );
   }
   
   public static Test suite() {
      return new TestSuite( TestDisplayAdvertisement.class );
   }
   
   public TestDisplayAdvertisement(String name) {      
      super(name);
   }
   
   /**
    * Verifies that the welcome page has exactly one form, 
    * with the single parameter, "name"
    */
   public void testMainPage() throws Exception  {
      WebConversation conversation = new WebConversation();
      WebRequest request = new GetMethodWebRequest( 
              "http://kuussaari.cs.helsinki.fi:5123/keltsi/main.jsp" );
      WebResponse response = conversation.getResponse(request);
      WebForm forms[] = response.getForms();
      String parameters = "";
      KeltsiDAML kd;
      DAMLProperty aPredicate;
      RDFNode aObject;
      ResultIterator instanceiter; 
      Service service;
      Advertisement adv;

      /* NodeList nodelist = response.getDOM().getElementsByTagName("input");

      LinkedList ll = new LinkedList();
      for(int i=0; i<nodelist.getLength(); ++i) {

	  Node node = nodelist.item(i);
	  ll.add(node.getAttributes().getNamedItem("name").getNodeValue());
	  
	  }*/

      /* Check parameter names. */
      parameters= forms[0].getParameterNames()[0] 
              + forms[0].getParameterNames()[1] 
              + forms[0].getParameterNames()[2];
      assertEquals( 3, forms[0].getParameterNames().length );
      assertTrue( parameters.indexOf("rdfPredicate") >= 0);
      assertTrue( parameters.indexOf("rdfSubject") >=0);
      assertTrue( parameters.indexOf("rdfObject") >=0);

      /* Query KeltsiDAML with form. */
      request.setParameter( "rdfPredicate", "Franchises" );
      request.setParameter( "rdfObject", "HairCuttingOrColorServices" );
      request = forms[0].getRequest();
      response = conversation.getResponse( request );

      /* Query direct from KeltsiDAML. */
      kd = new KeltsiDAML();;
      kd.loadModel("KeltsiData");

      aPredicate = (DAMLProperty) kd.getDAMLValue(
              kd.keltsiNS + "Franchises");

      aObject = (RDFNode) kd.getDAMLValue(
              kd.keltsiNS + "HairCuttingOrColorServices");
      
      instanceiter =
	  kd.select(null, (Property) aPredicate, aObject);

      /* Compare query results. */      
      while(instanceiter.hasNext() == true) {
	  service = Service
	      .getService((DAMLInstance) instanceiter.next());
	  adv = service.getAdvertisement();
      	  assertTrue(response.getText()
                             .indexOf(adv.getProviderOfService()) != -1);
      }
      
   /**
    * Verifies that submitting the login form without entering 
    * a name results in a page containing the text "Login failed"
    */
    /*   public void testBadLogin() throws Exception {
	
      WebConversation     conversation = new WebConversation();
      WebRequest  request = new GetMethodWebRequest( 
              "http://www.meterware.com/servlet/TopSecret" );
      
      WebResponse response = conversation.getResponse( request );
      WebForm loginForm = response.getForms()[0];
      request = loginForm.getRequest();
      response = conversation.getResponse( request );
      assertTrue( "Login not rejected", response.getText().indexOf( 
             "Login failed" ) != -1 );
	     }*/
   
   
   
   /**
    * Verifies that submitting the login form with the name "master" results
    * in a page containing the text "Top Secret"
    */
    /*   public void testGoodLogin() throws Exception {
      
      WebConversation     conversation = new WebConversation();
      WebRequest  request = new GetMethodWebRequest( "http://www.meterware.com/servlet/TopSecret" );
      
      WebResponse response = conversation.getResponse( request );
      WebForm loginForm = response.getForms()[0];
      request = loginForm.getRequest();
      request.setParameter( "name", "master" );
      response = conversation.getResponse( request );
      assertTrue( "Login not accepted", response.getText().indexOf( "You made it!" ) != -1 );
      
      assertEquals( "Page title", "Top Secret", response.getTitle() );
   } 
    */
   }   
}



