package fi.helsinki.cs.keltsi.jenardf;

import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.jena.daml.*;

import java.util.LinkedList;
import java.util.Iterator;

/* 
 *  Class to encapsulate an Advertisement, 
 *  or perhaps an Advertiser.
 *  Holds zero or more services to advertise.
 */
public class Advertisement extends KeltsiResource {

    /* 
     *  Constructor.
     *  Mostly accesed via Service.getAdvertisement().
     */
    Advertisement(DAMLInstance advertisement) {
        super(advertisement);
    }

    public ImageFile getImageFile() {
        try {
            DAMLInstance imageFileNode = (DAMLInstance)
                    getResource().getPropertyValue(Keltsi.imageFile);
            return new ImageFile(imageFileNode);
        } catch (Exception ex) {}
        return null;
    }

    public Iterator getServices() {
        LinkedList services = new LinkedList();
        NodeIterator iter = getResource()
                .getPropertyValues(Keltsi.services);
        try {
            while (iter.hasNext()) {
                services.add(getModel()
                        .getKeltsiResource((DAMLInstance)iter.next()));
            }
        } catch (Exception ex) {
            try {
                iter.close();
            } catch(Exception exx) {}
        }
        return services.iterator();
    }

    public String getLabel() {
        return getSingleLiteralValue(Keltsi.label);
    }

}
