package fi.helsinki.cs.keltsi.jenardf;

import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.jena.daml.*;

/*
 * Encapsulates a contact of a Service.
 * Should never be  constructed directly.
 * Accessed via method Service.getContacts().
 */
public class Contact extends KeltsiResource {
    private String address = "";
    private String email = "";
    private String fax = "";
    private String telephone = "";
    private String url = "";
    private String label = null;
    private String openingHours = null;

    Contact(DAMLInstance contact) {
        super(contact);
        address = getSingleLiteralValue(Keltsi.address);
        email = getSingleLiteralValue(Keltsi.email);
        fax = getSingleLiteralValue(Keltsi.fax);
        telephone = getSingleLiteralValue(Keltsi.telephone);
        url = getSingleLiteralValue(Keltsi.url);
        label = getSingleLiteralValue(Keltsi.label);
        openingHours = getSingleLiteralValue(Keltsi.openingHours);
    }

    public boolean hasLabel() {
        return (label != null);
    }
    
    public String getLabel() {
        return label;
    }

    public String getAddress() {
        return address;
    }

    public String getEmail() {
        return email;
    }

    public String getFax() {
        return fax;
    }

    public String getTelephone() {
        return telephone;
    }

    public String getUrl() {
        return url;
    }
    
    public String getOpeningHours() {
        return openingHours;
    }

}
