package fi.helsinki.cs.keltsi.jenardf;

import com.hp.hpl.jena.daml.*;
import java.util.Iterator;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.RDF;
import com.hp.hpl.mesa.rdf.jena.vocabulary.RDFS;
import java.util.LinkedList;

public class Ontology extends Object {
    KeltsiClass rangetop; //root;
    KeltsiClass domaintop;
    String verbs[];
    String label;
    
    public Ontology(KeltsiClass rangetop, String[] verbs, String label, KeltsiClass domaintop) {
        this.rangetop = rangetop;
        this.verbs = verbs;
        this.label = label;
        this.domaintop = domaintop;
    }

    public String defaultVerb () {
        if (verbs != null && verbs.length > 0) {
            return verbs[0];
        } else {
            return null;
        }
    }

    public KeltsiClass getRangeTop() {
        return rangetop;
    }
    
    public String[] getVerbs() {
        return verbs;
    }

    public String getLabel() {
        return label;
    }
    
    public KeltsiClass getDomainTop() {
        return domaintop;
    }

    public String getNameSpace() {
        return rangetop.getNameSpace();
    }

}
