package fi.helsinki.cs.keltsi.jenardf.test;

import junit.framework.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import fi.helsinki.cs.keltsi.jenardf.*;
import fi.helsinki.cs.keltsi.utils.*;

import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.RDF;
import com.hp.hpl.mesa.rdf.jena.vocabulary.RDFS;
import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.jena.rdf.query.*;

/**
 * Class to test Advertisement.
 */
public class TestAdvertisement extends TestCase {

	public TestAdvertisement(String theName) {
		super(theName);
	}

	/**
	 * main
	 * @param String[] arguments (not used)
	 */
	public static void main(String[] theArgs) {
		junit.textui.TestRunner.main
			(new String[] {TestAdvertisement.class.getName()});
	}

	/**
	 * Build a test <code>suite</code>.
	 */
	public static Test suite() {
		return new TestSuite(TestAdvertisement.class);
	}

	private static String kbNS = "http://protege.stanford.edu/kb#";
	private KeltsiJenaQuery kjq;
	public void setUp()
	{
		kjq = new KeltsiJenaQuery();
	}

	/**
	 * Methods for convenience to create two instances
	 */
	private Advertisement adv1 = null;
	private Advertisement adv1()
	{
		if (adv1 == null)
		{
			Resource res = (Resource)kjq.getResourceByURI
				(kbNS + "UNSPSC_00101");
			adv1 = new Advertisement(res, kjq);
		}
		return adv1;
	}

	private Advertisement adv2 = null;
	private Advertisement adv2()
	{
		if (adv2 == null)
		{
			Resource res = (Resource)kjq.getResourceByURI
				(kbNS + "UNSPSC_00418");
			adv2 = new Advertisement(res, kjq);
		}
		return adv2;
	}


	/**
	 * Test constructor
	 */
	public void testConstructor()
	throws Exception
	{
		assertTrue(adv1() != null);
		assertTrue(adv2() != null);
	}

	/**
	 * Test constructor
	 */
	public void testProviderOfService()
	throws Exception
	{
		assertTrue(adv1().providerOfService() != null);
		assertTrue(!adv1().providerOfService().equals(""));
		assertTrue(adv2().providerOfService() != null);
		assertTrue(!adv2().providerOfService().equals(""));
	}

	/**
	 * Test constructor
	 */
	public void testImageFileURL()
	throws Exception
	{
		assertTrue(adv1().imageFileURL() != null);
		assertTrue( adv1().imageFileURL().equals(""));
		assertTrue(adv2().imageFileURL() != null);
		assertTrue(!adv2().imageFileURL().equals(""));
	}

	public void testContact()
	throws Exception
	{
		assertTrue(adv1().contact() != null);
		assertTrue(adv2().contact() != null);
	}

}
