package fi.helsinki.cs.keltsi.util;

import java.util.Iterator;
import fi.helsinki.cs.keltsi.jenardf.*;
import com.hp.hpl.mesa.rdf.jena.model.StmtIterator;
import com.hp.hpl.mesa.rdf.jena.model.Statement;

public class ResultIterator implements java.util.Iterator
{
    private StmtIterator sIter;
    private int select;
        
    public ResultIterator(StmtIterator sIter, int select)
    {
        this.sIter = sIter;
        this.select = select;
    }

    public int getSelect() {
        return select;
    }

    public boolean hasNext()
    {
        if (sIter == null) return false;
        try
        {
            return sIter.hasNext();
        }
        catch (Exception ex)
        {
            return false;
        }
    }
        
    public void remove()
    {
        if (sIter != null) 
        try 
        {
            sIter.remove();
        }
        catch (Exception ex)
        {
        }
    }
        
    public Object next()
    {
        try {
            Statement stmt = sIter.next();
            switch (select)
            {
                case KeltsiDAML.SUBJECT: return stmt.getSubject();
                case KeltsiDAML.PREDICATE: return stmt.getPredicate();
                case KeltsiDAML.OBJECT: return stmt.getObject();
                default: return stmt;
            }
        }
        catch (Exception ex) {
            return null;
        }
    }
        
    public void close()
    {
        try {
            if (sIter != null) sIter.close();
        }
        catch (Exception ex) {
        }
    }

}

