/*
 *  (c) Copyright Hewlett-Packard Company 2000, 2001
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 * NTripleTest.java
 *
 * Created on November 28, 2001, 9:58 AM
 */

package com.hp.hpl.jena.rdf.arp.test;

import java.io.*;
import java.net.URL;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.mem.*;

import junit.framework.*;

/**
 *
 * @author  jjc

 */
class NTripleTest extends BaseTest {

    private InputStream inNT;
    /** Creates new NTripleTest */
    NTripleTest(String urlRDF,String urlNT) throws IOException {
        this(urlRDF,new URL(urlRDF).openStream(),new URL(urlNT).openStream());
    }
    /** Creates new NTripleTest */
    NTripleTest(String urlRDF, InputStream inRDF ,InputStream inNT) {
        super(urlRDF,inRDF);
        this.inNT = inNT;
    }
    
    /** Creates new NTripleTest */
    NTripleTest(String urlRDF, String inRDF ,String inNT) {
        this(urlRDF,new LazyFileInputStream(inRDF),new LazyFileInputStream(inNT));
    }
    
    protected void runTest() {
        try {
            Model m = new ModelMem();
           
            Reader rdr = new InputStreamReader(inNT);
            m.read(rdr,"","N-TRIPLE");
            loadRDF();
            assertEquals("RDF/XML & N-Triples file differ",m,model);
        }
        catch (RDFException re) {
            fail(re.getMessage());
        }
        catch (IOException ioe) {
            fail(ioe.getMessage());
        }
    }
    

}
