//--HEADER--
/*
 *  (c) Copyright Hewlett-Packard Company 2001
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * $Id: QSys.java,v 1.2 2002/05/01 11:44:28 andy_seaborne Exp $
 */
//--HEADER--

package com.hp.hpl.jena.rdf.query;

import com.hp.hpl.jena.util.Log ;

// Only public so the parser and other query subsystems cab use it.
/** Class to define the operating environment for RDQL.
 *  Provides some utility operations like assert and handling unexpected exceptions
 */

public class QSys
{
    public static void assertTrue(boolean condition, String msg, String className, String methodName)
    {
        if ( ! condition )
        {
            Log.severe(msg, className, methodName);
            throw new RDQL_InternalErrorException(className+"."+methodName+": "+msg) ;
        }
    }

    public static void unhandledException(Throwable t, String className, String methodName)
    {
        String tmp = Thread.currentThread().getName() ;
        Log.severe("("+tmp+") Unhandled exception", className, methodName, t) ;
    }
}
