//--HEADER--
/*
 *  (c) Copyright Hewlett-Packard Company 2001
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * $Id: Q_LeftShift.java,v 1.2 2001/12/05 10:29:37 afs Exp $
 */
//--HEADER--

package com.hp.hpl.jena.rdf.query.parser;

import com.hp.hpl.jena.rdf.query.* ;
import java.io.PrintWriter;

/* This file is automatically generated - do not edit.
 * Arguments: 
 *       Name = LeftShift
 *       Operator = <<
 *       Print Name = lshift
 *       Template = ExprNumericBLANK2.java
 */

/** Automatically generated class: Operator: LeftShift */

class Q_LeftShift extends SimpleNode implements Expr, ExprNumeric
{
    Expr left ;
    Expr right ;

    private String printName = "lshift" ;
    private String opSymbol = "<<" ;

    Q_LeftShift(int id) { super(id); }

    Q_LeftShift(RDQLParser p, int id) { super(p, id); }

    public Value eval(Query q, ResultBinding env)
    {
	int n = jjtGetNumChildren() ;

	Value x = left.eval(q, env) ;
	Value y = right.eval(q, env) ;

	if ( ! x.isNumber() )
	    throw new EvalTypeException("Q_LeftShift: Wanted a number: "+x) ;
	if ( ! y.isNumber() )
	    throw new EvalTypeException("Q_LeftShift: Wanted a number: "+y) ;
	
	Settable result ;
	if ( x instanceof Settable )
	    result = (Settable)x ;
	else if ( y instanceof Settable )
	    result = (Settable)y ;
	else
	    result = new WorkingVar() ;

	if ( x.isInt() && y.isInt() )
	    result.setInt(x.getInt() << y.getInt()) ;
	else
	    result.setLong(x.getLong() << y.getLong()) ;

	return result ;
    }

    // Could do some checking that children are numeric
    // Could collapse constant expressions

    public void jjtClose()
    {
	int n = jjtGetNumChildren() ;
	if ( n != 2 )
	    throw new QueryException("Q_LeftShift: Wrong number of children: "+n) ;
	
	left = (Expr)jjtGetChild(0) ;
	right = (Expr)jjtGetChild(1) ;
    }

    public String asInfixString()
    {
	return QueryFormatUtils.asInfixString2(left, right, printName, opSymbol) ;
    }

    public String asPrefixString()
    {
	return QueryFormatUtils.asPrefixString(left, right, printName, opSymbol) ;
    }

    public void print(PrintWriter pw, int level)
    {
	QueryFormatUtils.print(pw, left, right, printName, opSymbol, level) ;
    }

    public String toString()
    {
	return asInfixString() ;
    }
}
