//--HEADER--
/*
 *  (c) Copyright Hewlett-Packard Company 2001
 *  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * $Id: Q_URI.java,v 1.1 2001/09/19 09:28:31 afs Exp $
 */
//--HEADER--

/* Generated By:JJTree: Do not edit this line. Q_URI.java */

package com.hp.hpl.jena.rdf.query.parser ;

import com.hp.hpl.jena.rdf.query.* ;

class Q_URI extends Literal {

    // The form actually coming from the parser.
    String seen = "" ;

    // This is set false until the Q_URI is transformed into absolute form
    // or it is known to be.

    boolean isAbsolute = false ;

    Q_URI(int id)
    {
        super(id);
    }

    Q_URI(RDQLParser p, int id)
    {
        super(p, id);
    }

    void accumulate(String s)
    {
        seen = seen+s ;
    }

    public void jjtClose()
    {
        // Can't convert to absolute form until the entire query is parsed.
        // Don't need to do %-escape processing here because we work in string-space.
        // Easier to work on the version of URIs with the escape squcnes still in.
        //seen = processEscapes(seen) ;
        super.setURI(seen);
    }

    static public String processEscapes(String s)
    {
        StringBuffer result = new StringBuffer() ;
        // After end of last % seen
        int len = s.length() ;
        int k = 0 ;

        for ( ;; )
        {
            int i = s.indexOf("%", k) ;
            if ( ( i < 0 ) || ( i+2 >= len ) )
            {
                result.append(s.substring(k)) ;
                return result.toString() ;
            }
            result.append(s.substring(k,i)) ;

            int vHi = Character.digit(s.charAt(i+1),16) ;
            int vLo = Character.digit(s.charAt(i+2),16) ;
            result.append((char)(vHi*16+vLo)) ;
            k = i+3 ;
        }
    }

    public void fixup(Q_Query qnode)
    {
        if ( ! isAbsolute )
            absolute(qnode) ;
    }

    static final String prefixOperator = ":" ;

    private void absolute(Q_Query qnode)
    {
        int i = seen.indexOf(prefixOperator) ;
        if ( i < 0 )
        {
            isAbsolute = true ;
            return ;
        }

        String prefix = seen.substring(0,i) ;
        String full = (String)qnode.prefixMap.get(prefix) ;

        if ( full == null )
        {
            isAbsolute = true ;
            return ;
        }

        String remainder = seen.substring(i+prefixOperator.length()) ;
        super.setURI(full+remainder) ;
        isAbsolute = true ;
    }
}
