package com.meterware.httpunit;
/********************************************************************************************************************
* $Id: HttpUnitSuite.java,v 1.17 2002/02/28 14:30:33 russgold Exp $
*
* Copyright (c) 2000-2001, Russell Gold
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
* documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
* the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and
* to permit persons to whom the Software is furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial portions 
* of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
* THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
* CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
* DEALINGS IN THE SOFTWARE.
*
*******************************************************************************************************************/

import junit.framework.Test;
import junit.framework.TestSuite;


/**
 * Tests for the package.
 **/
public class HttpUnitSuite {

    public static void main( String[] args ) {
        junit.textui.TestRunner.run( suite() );
    }
	
	
    public static Test suite() {
        TestSuite result = new TestSuite();
        result.addTest( WebPageTest.suite() );
        result.addTest( WebLinkTest.suite() );
        result.addTest( HtmlTablesTest.suite() );
        result.addTest( WebFormTest.suite() );
        result.addTest( WebFrameTest.suite() );
        result.addTest( RequestTargetTest.suite() );
        result.addTest( FormParametersTest.suite() );
        result.addTest( FormSubmitTest.suite() );
        result.addTest( Base64Test.suite() );
        result.addTest( PseudoServerTest.suite() );
        result.addTest( WebClientTest.suite() );
        result.addTest( MessageBodyRequestTest.suite() );
        result.addTest( JTidyPrintWriterTest.suite() );
        addOptionalTestCase( result, "com.meterware.httpunit.XMLPageTest" );
        addOptionalTestCase( result, "com.meterware.httpunit.FileUploadTest" );
        return result;
    }


    private static void addOptionalTestCase( TestSuite testSuite, String testCaseName ) {
        try {
            testSuite.addTest( new TestSuite( Class.forName( testCaseName ) ) );
        } catch (ClassNotFoundException e) {
            System.out.println( "Note: test suite " + testCaseName + " not found; skipping." );
        }
    }


}

